using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using AddinExpress.OL;
  
namespace TestDPIChangedCS
{
    public partial class ADXOlForm1 : AddinExpress.OL.ADXOlForm
    {
        public ADXOlForm1()
        {
            InitializeComponent();

            userControl.GetDPI = () => DPI;
            userControl.GetDPIFactor = () => DPIFactor;
        }

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);
            UpdateControls();
        }

        private void UpdateControls()
        {
            Icon = GetIcon();
            userControl.UpdateControls();
        }

        private Icon GetIcon()
        {
            if (DPI >= 192)
                return Icon.FromHandle(Images.adx_32.GetHicon());
            else
                return Icon.FromHandle(Images.adx_16.GetHicon());
        }

        private void ADXOlForm1_ADXDPIChanged(object sender, ADXDPIChangedEventArgs e)
        {
            userControl.UpdateDPI(this, e.DPI, e.DPIFactor);
            UpdateControls();
        }
    }
}
