﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TestDPIChangedCS
{
    public partial class UserControl1 : UserControl
    {
        public UserControl1()
        {
            InitializeComponent();
        }

        internal Func<int> GetDPI = null;
        internal Func<float> GetDPIFactor = null;

        public int DPI
        {
            get { return GetDPI != null ? GetDPI() : 96; }
        }

        public float DPIFactor
        {
            get { return GetDPIFactor != null ? GetDPIFactor() : 1.0f; }
        }

        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);
            if (label4 != null)
                label4.Text = "TaskPane size: " + this.ClientSize.Width;
        }

        internal void UpdateControls()
        {
            label1.Text = "Current DPI: " + this.DPI;
            label4.Text = "TaskPane size: " + this.ClientSize.Width;
            button1.Text = string.Format("Button size - {0}x{1}", button1.Width, button1.Height);
            textBox1.Text = string.Format("Edit box size - {0}x{1}", textBox1.Width, textBox1.Height);
        }

        internal void UpdateDPI(Control root, int dpi, float dpiFactor)
        {
            foreach (Control cl in root.Controls)
            {
                cl.Bounds = Rectangle.Round(new RectangleF(cl.Left * dpiFactor, cl.Top * dpiFactor, cl.Width * dpiFactor, cl.Height * dpiFactor));
                if (cl.Controls.Count > 0)
                    UpdateDPI(cl, dpi, dpiFactor);
                cl.Font = new Font(cl.Font.FontFamily, cl.Font.Size * dpiFactor, cl.Font.Unit);
            }
        }

        Button newButton = null;

        private void button2_Click(object sender, EventArgs e)
        {
            if (newButton == null)
            {
                newButton = new Button();
                newButton.Location = new Point(button2.Right + 10, button2.Top);
                newButton.Size = new Size(button1.Right - newButton.Left, button2.Height);
                newButton.Text = "Test";
                Controls.Add(newButton);
            }
            else
            {
                newButton.Dispose();
                newButton = null;
            }

            button2.Text = newButton == null ? "Add button" : "Delete button";
        }
    }
}
