﻿Imports System.Drawing
Imports System.Windows.Forms

Public Class UserControl1
    Friend GetDPI As Func(Of Integer) = Nothing
    Friend GetDPIFactor As Func(Of Single) = Nothing

    Public ReadOnly Property DPI As Integer
        Get
            Return If(GetDPI IsNot Nothing, GetDPI(), 96)
        End Get
    End Property

    Public ReadOnly Property DPIFactor As Single
        Get
            Return If(GetDPIFactor IsNot Nothing, GetDPIFactor(), 1.0F)
        End Get
    End Property

    Protected Overrides Sub OnResize(e As System.EventArgs)
        MyBase.OnResize(e)
        If Not IsNothing(label4) Then
            label4.Text = "TaskPane size: " + Me.ClientSize.Width.ToString()
        End If
    End Sub

    Friend Sub UpdateControls()
        label1.Text = "Current DPI: " & Me.DPI
        label4.Text = "TaskPane size: " & Me.ClientSize.Width.ToString()
        button1.Text = String.Format("Button size - {0}x{1}", button1.Width, button1.Height)
        textBox1.Text = String.Format("Edit box size - {0}x{1}", textBox1.Width, textBox1.Height)
    End Sub

    Friend Sub UpdateDPI(ByVal root As Control, ByVal dpi As Integer, ByVal dpiFactor As Single)
        For Each cl As Control In root.Controls
            cl.Bounds = Rectangle.Round(New RectangleF(cl.Left * dpiFactor, cl.Top * dpiFactor, cl.Width * dpiFactor, cl.Height * dpiFactor))
            If cl.Controls.Count > 0 Then UpdateDPI(cl, dpi, dpiFactor)
            cl.Font = New Font(cl.Font.FontFamily, cl.Font.Size * dpiFactor, cl.Font.Unit)
        Next
    End Sub

    Private newButton As Button = Nothing

    Private Sub button2_Click(sender As Object, e As EventArgs) Handles button2.Click
        If newButton Is Nothing Then
            newButton = New Button()
            newButton.Location = New Point(button2.Right + 10, button2.Top)
            newButton.Size = New Size(button1.Right - newButton.Left, button2.Height)
            newButton.Text = "Test"
            Controls.Add(newButton)
        Else
            newButton.Dispose()
            newButton = Nothing
        End If

        button2.Text = If(newButton Is Nothing, "Add button", "Delete button")
    End Sub
End Class
